function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_check_is_maps_page(){
     //检测当前是否maps页面
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('wildberries')==-1){
                   chrome.tabs.create({ url: "https://www.wildberries.ru" });
            }
        }else{
            chrome.tabs.create({ url: "https://www.wildberries.ru" });
        }
    });
}

function util_get_date(){
    // 创建一个Date对象来获取当前日期
    let currentDate = new Date();
    // 获取年、月、日
    let year = currentDate.getFullYear();
    let month = (currentDate.getMonth() + 1).toString().padStart(2, '0'); // 月份从0开始，所以需要加1，并确保两位数
    let day = currentDate.getDate().toString().padStart(2, '0'); // 日期，确保两位数
    // 格式化为年月日
    let formattedDate = year + '-' + month + '-' + day;
    return formattedDate;
}

function get_expire(){
    var bg = chrome.extension.getBackgroundPage();
    bg.plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date === 'undefined'){
            $('.jihuo').show();
            $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
            $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_wb_1nian&type=maijia_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
            return;
        }else{
            console.log('expire_date');
            console.log(expire_date);
            expire_date = expire_date.replace('T00:00:00.000Z','');
            $('#expire_date').html(expire_date);
            if (util_check_expire(expire_date)) {
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_wb_1nian&type=maijia_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }
        }
    });
}

get_expire();

function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
        //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.storage_get(function (callback_data) {
            console.log('extract_catalog_products_export_clean');
            console.log(callback_data);
            //
            let expire_date = callback_data['expire'];
            if(typeof expire_date === 'undefined'){
                $('.jihuo').show();
                $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_wb_1nian&type=maijia_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                return;
            }else{
                console.log('expire_date');
                console.log(expire_date);
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_wb_1nian&type=maijia_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            }
            //通用导出
            chrome.storage.local.get(null, function(items) {
                let export_datas = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        let shangjia_about_contact_and_basic_info = items[key];
                        let export_data_item = {
                            '商品网址':shangjia_about_contact_and_basic_info['_shangjia_about_contact_and_basic_info_link'],
                            '卖家名': shangjia_about_contact_and_basic_info['_shangjia_maijia_name'],
                            '公司名':shangjia_about_contact_and_basic_info['_shangjia_company_name'],
                            '公司地址':shangjia_about_contact_and_basic_info['_shangjia_company_address'],
                            '品牌':shangjia_about_contact_and_basic_info['_shangjia_company_brand'],
                            '所属国家':shangjia_about_contact_and_basic_info['_shangjia_company_country'], //诚年
                            'ogrn':shangjia_about_contact_and_basic_info['_shangjia_company_ogrnip'],
                            '店铺评论数':shangjia_about_contact_and_basic_info['_shangjia_store_review_num'],
                            '店铺售卖数':shangjia_about_contact_and_basic_info['_shangjia_store_sold_num'],
                            '店铺加入时间':shangjia_about_contact_and_basic_info['_shangjia_store_add_year'],
                            '是否请求完成': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '是':'否',
                            '企业是否重复': (shangjia_about_contact_and_basic_info['_is_request'] == 2 && shangjia_about_contact_and_basic_info['_is_repeat'] == 1) ? '是':'',
                        }
                        export_datas.push(export_data_item);
                    }
                }
                //
                exportToExcel(export_datas, 'gycharm-wildberries-export-'+Date.now(), "Sheet1");
                //
            });
            //
            $('#message-info').html('');
            //
        });
        //
    });
}

extract_catalog_products_export_clean();

function extract_catalog_products_clean(){
    $('#extract-catalog-products-clean').click(function (){
        //
        if(confirm("确认清空吗?")){
            var bg = chrome.extension.getBackgroundPage();
            bg.storage_clear();
        }
        //
    });
}

extract_catalog_products_clean();
//
function extract_catalog_products_pause(){
    $('#extract-catalog-products-pause').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause'] == 1){
                    $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
                }else{
                    $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause();

//
function extract_catalog_products_pause_page(){
    $('#extract-catalog-products-pause-page').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_page_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause_page'] == 1){
                    $('#extract-catalog-products-pause-page').text('已关闭自动翻页采集,可点击开启');
                }else{
                    $('#extract-catalog-products-pause-page').text('已开启自动翻页采集,可点击暂停');
                }
            });
          //
        });
        //
    });
}
extract_catalog_products_pause_page();

//
function btn_pause_list_switch(){
    $('#btn-pause-list-switch').click(function (){
        util_check_is_maps_page();
        //
        var bg = chrome.extension.getBackgroundPage();
        bg.pause_list_switch(function (){
            bg.storage_get(function (callback_data) {
                if(callback_data['pause_list'] == 1){
                    $('#btn-pause-list-switch').text('已关闭列表采集,可点击开启');
                }else{
                    $('#btn-pause-list-switch').text('已开启列表采集,可点击暂停');
                }
            });
          //
        });
        //
    });
}
btn_pause_list_switch();
//
function data_process(){
    //$('#message-info').html('加载中...');
    var bg = chrome.extension.getBackgroundPage();
    //
    bg.get_data_process();
    //
    bg.data_process_get(function (callback_data) {
        //$('#message-info').html('');
        let data_process = callback_data['data_process'];
        let total_add_shangjia_num = 0;
        let has_caiji_geren_num = 0;
        let has_caiji_company_num = 0;
        if(typeof data_process !== 'undefined' ){
            total_add_shangjia_num = data_process['total_add_shangjia_num'];
            has_caiji_geren_num = data_process['has_caiji_geren_num'];
            has_caiji_company_num = data_process['has_caiji_company_num'];
            //
            $('#data_process').html("已添加<span>"+total_add_shangjia_num+"</span>个商品,已采集<span>"+has_caiji_geren_num+"</span>个");
            //
        }
        //
    });
}
data_process();

setInterval(data_process, 3000);
//
function jihuo(){
    $('#jihuo_btn').click(function (){
        util_check_is_maps_page();
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-info').html('');
        if(jihuo_text==''){
            $('#message-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {
                        var bg = chrome.extension.getBackgroundPage();
                        bg.plugin_set_expire(expire_date,function (){
                            expire_date = expire_date.replace('T00:00:00.000Z','');
                            $('#expire_date').html(expire_date);
                            $('.jihuo').hide();
                            $('#message-account-info').html('');
                        });
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin?plugin=vip_wb_1nian&type=maijia_plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();

//
function init(){
    var bg = chrome.extension.getBackgroundPage();
    bg.storage_get(function (callback_data) {
        if(callback_data.hasOwnProperty('pause') && callback_data['pause'] == 1){
            $('#extract-catalog-products-pause').text('后台采集已暂停,可点击开启');
        }else{
            $('#extract-catalog-products-pause').text('后台采集已开启,可点击暂停');
        }
        $('#extract-catalog-products-pause').show();
        //自动翻页采集
        if(callback_data.hasOwnProperty('pause_page') && callback_data['pause_page'] == 1){
            $('#extract-catalog-products-pause-page').text('已关闭自动翻页采集,可点击开启');
        }else{
            $('#extract-catalog-products-pause-page').text('已开启自动翻页采集,可点击暂停');
        }
        //$('#extract-catalog-products-pause-page').hide();
        //
        //列表页采集
        if(callback_data.hasOwnProperty('pause_list') && callback_data['pause_list'] == 1){
            $('#btn-pause-list-switch').text('已关闭列表页采集,可点击开启');
        }else{
            $('#btn-pause-list-switch').text('已开启列表采集,可点击暂停');
        }
        //文件名
        if(callback_data.hasOwnProperty('field_name')){
            $('#field_name').val(callback_data['field_name']);
        }
        //
    });
}
init();
//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到tbm_map_urls:", req.maijia_num)

    if(req.action == 'update-shangjia-num'){
        var catalog_products_num = 0;
        var maijia_num = req.maijia_num;
        $('.catalog-products-num').html(maijia_num);
    }else if(req.action == 'background-tips'){
        //
        $('#message-info').html("<div style='color:red'>"+req.info+"</div>");
        //
         //
        chrome.tabs.create({ url: req.url });
        //
    }

    //sendRes("popup已经收到")

  })
//

function send_message_to_background(message={}){
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message, function(response) {
      console.log("收到来自background.js的响应: " + response);
    });
}
//
document.getElementById("opnFacebook").addEventListener('click', function () {
  chrome.tabs.create({ url: "https://www.wildberries.ru" });
})
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}
//
function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

function exportToCsv(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".csv");
}

function extract_product_lunbo_imgs(){
    $('#extract-product-lunbo-imgs').click(function (){
        $('#message-info').html('处理中...')
        console.log('extract-product-lunbo-imgs');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract-product-lunbo-imgs',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content')
                console.log(res)
                //
            })
        })
        //
    });
}

extract_product_lunbo_imgs();

function extract_product_details_imgs(){
    $('#extract-product-details-imgs').click(function (){
        $('#message-info').html('处理中...')
        console.log('extract-product-details-imgs');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract-product-details-imgs',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content')
                console.log(res)
                //
            })
        })
        //
    });
}

extract_product_details_imgs();

function extract_products_lunbo_imgs(){
    $('#extract-products-lunbo-imgs').click(function (){
       if (window.confirm("确定要下载吗？下载时浏览器当前页面保持不动！")) {
           util_check_is_maps_page();
           var bg = chrome.extension.getBackgroundPage();
           bg.storage_get(function (callback_data) {
               let expire_date = callback_data['expire'];
               if (typeof expire_date === 'undefined') {
                   $('.jihuo').show();
                   $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                   $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                   return;
               } else {
                   console.log('expire_date');
                   console.log(expire_date);
                   expire_date = expire_date.replace('T00:00:00.000Z', '');
                   $('#expire_date').html(expire_date);
                   if (util_check_expire(expire_date)) {
                       $('.jihuo').show();
                       $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                       $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                       return;
                   }
               }
           });
           //
           chrome.storage.local.get(null, function(items) {
                let galleryimgs = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];
                            for(let i=0;i<_shangjia_gallery_arr.length;i++){
                                let _img = _shangjia_gallery_arr[i];
                                let _img_src = _img;
                                let _imgarr = _img.split('/');
                                let _img_name = _imgarr[_imgarr.length-1];
                                let _img_name_arr = _img_name.split('.');
                                _img_name = _img_name_arr[0];
                                _img_name = shangjia_about_contact_and_basic_info['_shangjia_goodsId']+'_'+_img_name;
                                //
                                galleryimgs.push({
                                    'url':  _img_src,
                                    'name': _img_name
                                });
                            }
                        }
                    }
                }
                //
                // popup ---> content
                chrome.tabs.query({
                    active: true,
                    currentWindow: true
                }, (tabs) => {
                    let message = {
                        action: 'extract_products_lunbo_imgs',
                        info: '',
                        galleryimgs:galleryimgs
                    }
                    chrome.tabs.sendMessage(tabs[0].id, message, res => {
                        console.log('popup=>content')
                        console.log(res)
                        //
                    })
                })
                //
            });
           //
       }
    });
}
extract_products_lunbo_imgs();


function extract_products_detail_imgs(){
    $('#extract-products-details-imgs').click(function (){
       if (window.confirm("确定要下载吗？下载时浏览器当前页面保持不动！")) {
           util_check_is_maps_page();
           var bg = chrome.extension.getBackgroundPage();
           bg.storage_get(function (callback_data) {
               let expire_date = callback_data['expire'];
               if (typeof expire_date === 'undefined') {
                   $('.jihuo').show();
                   $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                   $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                   return;
               } else {
                   console.log('expire_date');
                   console.log(expire_date);
                   expire_date = expire_date.replace('T00:00:00.000Z', '');
                   $('#expire_date').html(expire_date);
                   if (util_check_expire(expire_date)) {
                       $('.jihuo').show();
                       $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                       $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                       return;
                   }
               }
           });
           //
           chrome.storage.local.get(null, function(items) {
                let detailsimgs = [];
                //
                for (let key in items) {
                    if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                        if (items[key]['_is_request'] == 2) {
                            let shangjia_about_contact_and_basic_info = items[key];
                            let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
                            for(let i=0;i<_shangjia_productDetailFlatList.length;i++){
                                let _img = _shangjia_productDetailFlatList[i];
                                let _img_src = _img;
                                let _imgarr = _img.split('/');
                                let _img_name = _imgarr[_imgarr.length-1];
                                let _img_name_arr = _img_name.split('.');
                                _img_name = _img_name_arr[0];
                                _img_name = shangjia_about_contact_and_basic_info['_shangjia_goodsId']+'_detail_'+_img_name;
                                //
                                detailsimgs.push({
                                    'url':  _img_src,
                                    'name': _img_name
                                });
                            }
                        }
                    }
                }
                //
                // popup ---> content
                chrome.tabs.query({
                    active: true,
                    currentWindow: true
                }, (tabs) => {
                    let message = {
                        action: 'extract_products_detail_imgs',
                        info: '',
                        detailsimgs:detailsimgs
                    }
                    chrome.tabs.sendMessage(tabs[0].id, message, res => {
                        console.log('popup=>content')
                        console.log(res)
                        //
                    })
                })
                //
            });
           //
       }
    });
}
extract_products_detail_imgs();