// 使用自定义函数解析查询字符串并返回参数对象
function util_getCurrentUrlQueryStringParams() {
    // 获取当前URL的查询字符串部分
    var queryString = window.location.search;
    var params = {};
    // 移除开头的问号
    queryString = queryString.substring(1);
    // 分割成键值对数组
    var keyValuePairs = queryString.split('&');
    // 遍历键值对数组，将每一对分割成键和值，并存入params对象
    keyValuePairs.forEach(function(keyValuePair) {
        var pair = keyValuePair.split('=');
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1] || '');
        params[key] = value;
    });
    return params;
}

async function fetch_request(url){
     console.log('fetch request url:'+url);
     var return_html = '';
     let options = {
         method: 'get',
         headers: {
            // 'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

function ajax_get_json(url){
    console.log('json url:'+url);
    var data_d_val = [];
    //str_val = eval(str);
    //console.log(str_val);
    //return;
    var exhibitors_ajax = $.ajax({
             url:url,
             data: {},
             type: 'GET',
             async:false,
             //dataType: 'html',
             //contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             contentType:'application/json;charset=utf-8',
             crossDomain: true,
             dataType: "text",
             cache: false,
             success: function(data) {

                 console.log('jjjj');
                 console.log(data);

                 var data_json = $.parseJSON(data);
                 console.log(data_json);
                 console.log('complete');

             },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
            }
         });
    return data_d_val;
    //
}

function shangjia_search_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=> {
            console.log('can_list_caiji 答复', msg)
            let msgobj = JSON.parse(msg);
            console.log(msgobj['state']);
            if (msgobj['state'] == 0) { //可以自动采集
                //
                console.log('shangjia_search_caiji');
                let current_url = window.location.href;
                if(current_url) {
                    //
                    if (true) {
                        var shangjia_infos = [];
                        $(".product-card-list article.product-card").each(function (){
                            console.log('shangjia_search_caiji a3');
                            let _shangjia_name = '';
                            let _shangjia_brand = '';

                            let _shangjia_a_link = $(this).find('a.product-card__link').attr('href');
                            if(_shangjia_a_link){
                                //
                                let _shangjia_id = _shangjia_a_link;
                                //
                                _shangjia_name = $(this).find('a.product-card__link').attr('aria-label');
                                _shangjia_brand = $(this).find('.product-card__brand').text();
                                if(_shangjia_brand.length ==0){
                                    _shangjia_brand = '';
                                }
                                //
                                let _shangjia_info = {
                                    '_shangjia_id': _shangjia_id,
                                    '_shangjia_name': _shangjia_name,
                                    '_shangjia_a_link':_shangjia_a_link,
                                    '_shangjia_brand':_shangjia_brand
                                };
                                //console.log(_shangjia_info);
                                shangjia_infos.push(_shangjia_info);
                                //
                            }
                        });
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        //send_message_to_popup(message);
                        console.log('message');
                        console.log(message);
                        chrome.runtime.sendMessage(message,(msg)=>{
                            console.log('答复',msg);
                            alert('添加商品列表到插件成功!');
                        })
                       //zidong_caiji_next();
                    }
                }
                //
            }
        })
    },1000);
}

function zidong_caiji_next(){
    console.log('zidong_caiji_next s');
        let seemore_dom =  $(".reptile_paging__bottom .reptile_paging #reptile-paging-bottom-next button");
        var message = {
            action: 'can_zidong_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=>{
            console.log('zidong_caiji_next 答复',msg)
            let msgobj  = JSON.parse(msg);
            console.log(msgobj['state']);
            if(msgobj['state'] == 0){ //可以自动采集
                console.log('zidong_caiji_next s2');
                //
                seemore_dom.click();
                //
            }
        })
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
       if(performanceResourceItem['initiatorType'] == 'fetch'){
            //找供应商
            if((performanceResourceItem['name'].indexOf('exactmatch/ru/common/v4/search')!=-1 && performanceResourceItem['name'].indexOf('resultset=catalog')!=-1) ||
                (performanceResourceItem['name'].indexOf('/catalog/')!=-1 && performanceResourceItem['name'].indexOf('catalog?')!=-1 && performanceResourceItem['name'].indexOf('filters?')==-1)){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function() {
                    //shangjia_search_caiji();
                }, 5000);
                //
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//
function add_products_btn(){
    console.log('add_products_btn');
    let current_url = window.location.href;
    // 创建一个按钮元素
    console.log('add_export_pingtai_btn a1');
    if(current_url && (current_url.indexOf('catalog')!=-1 && current_url.indexOf('detail')==-1 && current_url.indexOf('feedbacks')==-1)){
        var add_products_btn = $("<button>", {
            text: '添加列表商品到插件', // 按钮文本
            style: "display: block;\n" +
                    "    position: absolute;\n" +
                    "    bottom: 350px;\n" +
                    "    right: 10px;\n" +
                    "    z-index: 999;\n" +
                    "    background: #fb7701;\n" +
                    "    width: 180px;\n" +
                    "    height: 46px;\n" +
                    "    line-height: 46px;\n" +
                    "    color: #FFF;\n" +
                    "    font-weight: bold;\n" +
                    "    border-radius: 22px;",
            click: function() {
                //
                shangjia_search_caiji();
                //
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('.main').append(add_products_btn);
    //
    }

}
//
$(document).ready(function () {
    //
    setTimeout(function (){
        add_products_btn();
    },2000);
     setTimeout(function() {
        shangjia_new_tab_process_item_step2();
     }, 2000);
    //
});

function util_scrollToBottom(iframe, callback) {
    var iframeWindow = iframe.contentWindow;
    var start = iframeWindow.pageYOffset; // 当前滚动位置
    var end = iframeWindow.document.body.scrollHeight - iframeWindow.innerHeight; // 滚动到底部

    var duration = 8000; // 3 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        iframeWindow.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function util_currentpage_scrollToBottomWithCallback(callback) {
    var start = window.pageYOffset; // 当前滚动位置
    var end = document.documentElement.scrollHeight - window.innerHeight; // 滚动到底部

    var duration = 8000; // 8 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        window.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function shangjia_new_tab_process_item(need_item){
    console.log('shangjia_new_tab_process_item a1');
    //$('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
    //
    // 在新标签页中打开指定的 URL
    var message = {
        action: 'open_new_tab',
        info: '',
        need_item: need_item
    };
    send_message_to_popup(message);
    //
}

function shangjia_new_tab_process_item_step2(){
    let currentUrl = window.location.href;
    if(currentUrl.indexOf('167601226') !=-1){
        return;
    }
    if(currentUrl.indexOf('detail') != -1){
        setTimeout(function() {
            console.log('currentUrl:'+currentUrl);
            //
            let _shangjia_a_link = currentUrl;
            let query_params = util_getCurrentUrlQueryStringParams();
            if(query_params.hasOwnProperty('_shangjia_about_contact_and_basic_info_link_key')){
                let _shangjia_about_contact_and_basic_info_link_key = query_params['_shangjia_about_contact_and_basic_info_link_key'];
                //
                let need_item = {};
                need_item['_shangjia_about_contact_and_basic_info_link_key'] = _shangjia_about_contact_and_basic_info_link_key;
                //
                let _img_src = $('img.photo-zoom__preview').attr('src');
                console.log('_img_src');
                console.log(typeof _img_src);
                console.log(_img_src);
                //https://basket-10.wbbasket.ru/vol1427/part142788/142788666/images/big/1.webp
                //https://basket-10.wbbasket.ru/vol1554/part155405/155405992/info/sellers.json
                if(_img_src){
                    let _img_src_arr = _img_src.split('images');
                    let _seller_info_url = _img_src_arr[0]+'info/sellers.json';
                    //let _seller_info_arr = ajax_get_json(_seller_info_url);
                    let return_html = fetch_request(_seller_info_url);
                    return_html.then((data) => {
                        if(data){
                            //
                            console.log('_seller_info_url:'+_seller_info_url);
                            console.log(data);
                            var data_json = $.parseJSON(data);
                            console.log(data_json);
                            //
                            let _shangjia_maijia_name = data_json['supplierName'];

                            let _shangjia_company_name = '';
                            if(data_json.hasOwnProperty('supplierFullName')){
                                _shangjia_company_name = data_json['supplierFullName'];
                            }
                            let _shangjia_company_brand = '';
                            if(data_json.hasOwnProperty('trademark')){
                                _shangjia_company_brand = data_json['trademark'];
                            }
                            let _shangjia_company_country = '';
                            if(data_json.hasOwnProperty('countryLocCode')){
                                _shangjia_company_country = data_json['countryLocCode'];
                            }
                            let _shangjia_company_ogrnip = '';
                            if(data_json.hasOwnProperty('ogrnip')){
                                _shangjia_company_ogrnip = data_json['ogrnip']
                            }
                            //
                            let _shangjia_store_review_num = $('.seller-info__review-marks:eq(0)').text();
                            if(_shangjia_store_review_num){
                                _shangjia_store_review_num = _shangjia_store_review_num.replace('оценок','').replace('оценки','').trim();
                            }
                            let _shangjia_store_sold_num = $('.seller-info__item--delivered:eq(0)').find('.seller-info__value').text();
                            let _shangjia_store_add_year = $('.seller-info__item--time:eq(0)').find('.seller-info__value').text();
                            if(_shangjia_store_add_year){
                                _shangjia_store_add_year = _shangjia_store_add_year.replace('года','年').replace('мес','月');
                            }
                            let _shangjia_company_address = '';
                            if(data_json.hasOwnProperty('legalAddress')){
                                _shangjia_company_address = data_json['legalAddress']
                            }
                            //
                            if(_shangjia_maijia_name){
                                _shangjia_store_review_num = _shangjia_store_review_num.replaceAll(' ','');
                                _shangjia_store_sold_num = _shangjia_store_sold_num.replaceAll(' ','');

                                need_item['_shangjia_maijia_name'] = _shangjia_maijia_name;
                                need_item['_shangjia_company_name'] = _shangjia_company_name;
                                need_item['_shangjia_company_brand'] = _shangjia_company_brand;
                                need_item['_shangjia_company_country'] = _shangjia_company_country;
                                need_item['_shangjia_company_ogrnip'] = _shangjia_company_ogrnip;
                                need_item['_shangjia_store_review_num'] = _shangjia_store_review_num;
                                need_item['_shangjia_store_sold_num'] = _shangjia_store_sold_num;
                                need_item['_shangjia_store_add_year'] = _shangjia_store_add_year;
                                need_item['_shangjia_company_address'] = _shangjia_company_address;
                                // 在新标签页中打开指定的 URL
                                var message = {
                                    action: 'shangjia_new_tab_process_item_step2_complete',
                                    info: '',
                                    shangjia_info:need_item
                                };
                                //send_message_to_popup(message);
                                console.log('message');
                                console.log(message);
                                chrome.runtime.sendMessage(message,(msg)=>{
                                    console.log('答复',msg)
                                    //let msgobj = JSON.parse(msg);
                                    //
                                    var message = {
                                        action: 'closeTab',
                                        info: ''
                                    };
                                    send_message_to_popup(message);
                                    //
                                })
                            }
                            //
                        }else{
                            //对于访问异常的请求,直接过滤

                        }
                    });

                }
            }
        },5000);

    }
}

//打开指定采集页面开始采集
function process_caiji_taobao_item(){
    console.log('process_caiji_taobao_item s');
    //
    let current_url = window.location.href;
    if(current_url && current_url.indexOf('167601226') != -1) {
         $('.wrapper').hide();
         $('#gycharm-custom-msg').remove();
         var message = {
             action: 'caiji_item_get_taobao',
             info: ''
         };
         chrome.runtime.sendMessage(message, (msg) => {
             console.log('process_caiji_taobao_item 答复', msg)
             let msgobj = JSON.parse(msg);
             let need_item = msgobj['need_item'];
             //console.log(msgobj['need_item']);
             if (need_item) {
                 //
                 $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>正在采集:"+need_item['_shangjia_about_contact_and_basic_info_link']+"</div>");
                 //shangjia_insert_iframe_and_get_content_taobao(need_item);
                 shangjia_new_tab_process_item(need_item);
             }else{
                 //
                 if(msgobj['status'] == 1){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>后台采集已暂停，可以在插件工具里开启后台采集</div>");
                    //
                 }else if(msgobj['status'] ==3){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>目前已有商品在采集，稍等</div>");
                    //
                 }else if(msgobj['status'] ==2){
                     $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;margin-top:20px;'>所有商品已采集完成</div>");
                    //
                 }
             }
         })
        //
    }
}

function xintiao(){
    process_caiji_taobao_item();
}
xintiao();
setInterval(xintiao, 15000);

//
//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}
// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
})
//